﻿using System.IO;
using System.Windows.Browser;
using System.Windows;
using System.Collections.Generic;
using System;
using System.Windows.Input;
using System.Windows.Media;
using ThinkGeo.MapSuite.SilverlightEdition;
using ThinkGeo.MapSuite.SilverlightCore;
using System.Collections.ObjectModel;
using System.Windows.Media.Imaging;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Beetle.Silverlight.Controls;
using System.Windows.Media.Animation;

namespace MapPerformance
{
	public partial class MainPage : UserControl
	{
        MapDetails m_MapDetails = new MapDetails();
        ValueStyle vs = new ValueStyle();
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
            this.Loaded +=new RoutedEventHandler(MainPage_Loaded);
		}

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapTools.MouseCoordinate.MouseCoordinateType = MouseCoordinateType.LatitudeLongitude;
            Map1.MapTools.PanZoomBar.IsEnabled = true;
            Map1.MapUnit = GeographyUnit.Meter;
            Map1.MapTools.MouseCoordinate.IsEnabled = true;
            Map1.Background = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
            ServerLayerOverlay overlay = new ServerLayerOverlay("CanaveralMap1Server", "SilverlightMapConnector1");
            Map1.Overlays.Add("CanaveralMap1Server", overlay);
            ServerLayerOverlay overlay1 = new ServerLayerOverlay("CanaveralMap2Server", "SilverlightMapConnector1");
            Map1.Overlays.Add("CanaveralMap2Server", overlay1);
            ServerLayerOverlay overlay2 = new ServerLayerOverlay("CanaveralMap3Server", "SilverlightMapConnector1");
            Map1.Overlays.Add("CanaveralMap3Server", overlay2);
            Map1.CurrentExtent = new RectangleShape(533181.490451491, 3144268.68096696, 544626.363014241, 3138546.24468558);
            Map1.Refresh();
            m_MapDetails.lstNotSelectedMaps.Add("CanaveralMap1Server");
            m_MapDetails.lstNotSelectedMaps.Add("CanaveralMap2Server");
            m_MapDetails.lstNotSelectedMaps.Add("CanaveralMap3Server");

            lstBoxAvailableMaps.ItemsSource = null;
            lstBoxSelectedMaps.ItemsSource = null;
            lstBoxAvailableMaps.ItemsSource = m_MapDetails.lstNotSelectedMaps;
            lstBoxSelectedMaps.ItemsSource = m_MapDetails.lstSelectedMaps;



            double x = 537530.542025336;
            double y = 3142780.8475;
            GeoFont font=new GeoFont("Arial",50,true);
            TextStyle txtStyle = new TextStyle("Name",new GeoFont("Arial",40),new GeoSolidBrush(new GeoColor(255,0,0)));
             txtStyle.SuppressPartialLabels = false;

            ///key
            InMemoryFeatureLayer inMemoryFeatureLayer = new InMemoryFeatureLayer();
            inMemoryFeatureLayer.Columns.Add(new FeatureSourceColumn("State"));
            inMemoryFeatureLayer.Columns.Add(new FeatureSourceColumn("Name"));

            //inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.StandardColors.Blue, 50);
            CreateValueStyle();
            inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(vs);
            //add txt style to inmf
            inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(txtStyle);
            inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            PointShape Radarpoint = new PointShape(x, y);
           
            
            //inMemoryFeatureLayer.InternalFeatures.Add(pointFeature.Id, pointFeature);
            Feature f = new Feature(new PointShape(x, y));
            f.ColumnValues["State"] = "fail";
            // set feature colomn value
            f.ColumnValues["Name"] = "asfoojhiodfhidbfgdbgfdgfdgtf";
           
            // Add feature to in mem layer
            inMemoryFeatureLayer.InternalFeatures.Add(f);
            
            LayerOverlay layerFeatureOverlay = new LayerOverlay();
        
            layerFeatureOverlay.Layers.Add("radar", inMemoryFeatureLayer);
            Map1.Overlays.Add("AustinOverlay", layerFeatureOverlay);
            
                 }

        private void CreateValueStyle()
        {
            vs.ColumnName = "state";
            vs.ValueItems.Add(new ValueItem("ok",new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(new GeoColor(255,0,0)),20)));
            vs.ValueItems.Add(new ValueItem("fail", new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(new GeoColor(0, 255, 0)), 20)));

        }

		private void AddMap(string strMapName)
        {
            string path =    @"D:\Log.txt";
           
            //System.IO.FileStream fs = new FileStream(path, FileMode.Append, FileAccess.Write);
            //StreamWriter sw = new StreamWriter(fs);
            //sw.WriteLine(strMapName+"Maps visibility is set to visible");          
            ServerLayerOverlay overlay = (ServerLayerOverlay)Map1.Overlays[strMapName];
            overlay.Visibility = Visibility.Visible;
            
            Map1.Refresh();
            //sw.WriteLine("Map is refreshed");
            //sw.Close();
            //fs.Close();
        }

        private void RemoveMap(string strMapName)
        {
            ServerLayerOverlay overlay = (ServerLayerOverlay)Map1.Overlays[strMapName];
            overlay.Visibility = Visibility.Collapsed;

            Map1.Refresh();
        }
		
        private void btnActivateSingle_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if (lstBoxAvailableMaps.SelectedItems.Count > 0)
            {
                m_MapDetails.lstSelectedMaps.Add(lstBoxAvailableMaps.SelectedItems[0].ToString());
                lstBoxSelectedMaps.ItemsSource = null;
                lstBoxSelectedMaps.ItemsSource = m_MapDetails.lstSelectedMaps;
                AddMap(lstBoxAvailableMaps.SelectedItems[0].ToString());
                m_MapDetails.lstNotSelectedMaps.Remove(lstBoxAvailableMaps.SelectedItems[0].ToString());
                lstBoxAvailableMaps.ItemsSource = null;
                lstBoxAvailableMaps.ItemsSource = m_MapDetails.lstNotSelectedMaps;
            }
        }

        private void btnRemoveSingle_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            if(lstBoxSelectedMaps.SelectedItems.Count > 0)
            {
                RemoveMap(lstBoxSelectedMaps.SelectedItems[0].ToString());
                m_MapDetails.lstNotSelectedMaps.Add(lstBoxSelectedMaps.SelectedItems[0].ToString());
                lstBoxAvailableMaps.ItemsSource = null;
                lstBoxAvailableMaps.ItemsSource = m_MapDetails.lstNotSelectedMaps;
                m_MapDetails.lstSelectedMaps.Remove(lstBoxSelectedMaps.SelectedItems[0].ToString());
                lstBoxSelectedMaps.ItemsSource = null;
                lstBoxSelectedMaps.ItemsSource = m_MapDetails.lstSelectedMaps;
            }
        }

        private void btnRemoveAll_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            List<string> ItemsToRemove = new List<string>();
            foreach (string strName in lstBoxSelectedMaps.Items)
            {
                //lstBoxAvailableMaps.Items.Add(itms);
                ItemsToRemove.Add(strName);
                RemoveMap(strName);

                m_MapDetails.lstNotSelectedMaps.Add(strName);
                lstBoxAvailableMaps.ItemsSource = null;
                lstBoxAvailableMaps.ItemsSource = m_MapDetails.lstNotSelectedMaps;
            }

            foreach (string strItemsToRemove in ItemsToRemove)
            {
                m_MapDetails.lstSelectedMaps.Remove(strItemsToRemove);
                lstBoxSelectedMaps.ItemsSource = null;
                lstBoxSelectedMaps.ItemsSource = m_MapDetails.lstSelectedMaps;
            }
        }

        private void btnActivateAll_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            foreach (string strName in lstBoxAvailableMaps.Items)
            {
                m_MapDetails.lstSelectedMaps.Add(strName);
                lstBoxSelectedMaps.ItemsSource = null;
                lstBoxSelectedMaps.ItemsSource = m_MapDetails.lstSelectedMaps;
                AddMap(strName);
                m_MapDetails.lstNotSelectedMaps.Remove(strName);
                lstBoxAvailableMaps.ItemsSource = null;
                lstBoxAvailableMaps.ItemsSource = m_MapDetails.lstNotSelectedMaps;
            }
        }

        private void Map1_ExtentChanged(object sender, ExtentChangedEventArgs e)
        {
            ProjNetProjection proj = new ProjNetProjection(4326, 2150);
            proj.Open();
            RectangleShape rs = proj.ConvertToInternalProjection(e.CurrentExtent);
            proj.Close();

            m_MapDetails.UpperLeftLat = rs.UpperLeftPoint.Y;
            m_MapDetails.UpperLeftLon = rs.UpperLeftPoint.X;
            m_MapDetails.LowerRightLat = rs.LowerRightPoint.Y;
            m_MapDetails.LowerRightLon = rs.LowerRightPoint.X;

            RectangleShape Extent = new RectangleShape();
            Extent.UpperLeftPoint.Y = Convert.ToDouble(m_MapDetails.UpperLeftLat);
            Extent.UpperLeftPoint.X = Convert.ToDouble(m_MapDetails.UpperLeftLon);
            Extent.LowerRightPoint.Y = Convert.ToDouble(m_MapDetails.LowerRightLat);
            Extent.LowerRightPoint.X = Convert.ToDouble(m_MapDetails.LowerRightLon);

            proj.Open();
            RectangleShape rs1 = proj.ConvertToExternalProjection(Extent);
            proj.Close();

            Map2.CurrentExtent = rs1;
            Map2.Refresh();
        }

        private void MyUserControl_SizeChanged(object sender, SizeChangedEventArgs e)
        {            
            //Dispatcher.BeginInvoke(() =>
            //{
            //    Map1.Width = e.NewSize.Width - MyRadSplitCont.ActualWidth;
            //    Map1.Height = e.NewSize.Height - 18;
            //});
        }

        private void MyRadSplitCont_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            //Dispatcher.BeginInvoke(() =>
            //{
            //    Map1.Width = MyUserControl.ActualWidth - e.NewSize.Width;
            //});
        }
	}

    public class MapDetails
    {
        public object m_MinThreshold;
        public object m_MaxThreshold;
        public object m_UpperLeftLat;
        public object m_UpperLeftLon;
        public object m_LowerRightLat;
        public object m_LowerRightLon;
        public object m_Units;
        public object m_CoordinateSystem;
        public object m_CanvasColor;
        public object m_ForeColor;
        public object m_ExternalEpsgNumber;
        public object m_InternalEpsgNumber;
        public List<string> lstNotSelectedMaps = new List<string>();
        public List<string> lstSelectedMaps = new List<string>();

        public object MinThreshold
        {
            get
            {
                return m_MinThreshold;
            }
        }
        public object MaxThreshold
        {
            get
            {
                return m_MaxThreshold;
            }
        }
        public object UpperLeftLat
        {
            get
            {
                return m_UpperLeftLat;
            }
            set
            {
                m_UpperLeftLat = value;
            }
        }
        public object UpperLeftLon
        {
            get
            {
                return m_UpperLeftLon;
            }
            set
            {
                m_UpperLeftLon = value;
            }
        }
        public object LowerRightLat
        {
            get
            {
                return m_LowerRightLat;
            }
            set
            {
                m_LowerRightLat = value;
            }
        }
        public object LowerRightLon
        {
            get
            {
                return m_LowerRightLon;
            }
            set
            {
                m_LowerRightLon = value;
            }
        }
        public object Units
        {
            get
            {
                return m_Units;
            }
        }
        public object CoordinateSystem
        {
            get
            {
                return m_CoordinateSystem;
            }
        }
        public object CanvasColor
        {
            get
            {
                return m_CanvasColor;
            }
        }
        public object ForeColor
        {
            get
            {
                return m_ForeColor;
            }
        }
    }
}